-- File name   : RA2_TOOLSET.MS
-- Title       : RED ALERT2 tools
-- Category    : not implemented yet
-- Environment : 3ds max 3&4, GMAX
-- Description : toolset for RA2 SHP building
-- Reference   :
-- Copyright (c) 2002 by Flyby
-- VERSION		: 1.2

-- Edited by pd, 2005
-- with permission from Flyby


-- Let the games begin..... -----------------------------------------------

global animX,animY

rollout SETUPTOOLS "RA2   SETUP TOOLS" 
(
--local camd
--grptxt01="3DSMAX render" as string

group "Reference Foundation"
	(
	label labtxt01 "RIGHT" align:#left
	radiobuttons reffnd_R labels:#("1","2","3","4","5","6")  align:#centre height:20 columns:6
	label labtxt02 "LEFT" align:#left
	radiobuttons reffnd_L labels:#("1","2","3","4","5","6")  align:#centre height:20 columns:6
--	label labtxt03 "HEIGHT" align:#left
--	radiobuttons reffnd_H labels:#("1","2","3","4","5","6")  align:#centre height:20 columns:6
	button do_reffnd " Create Reference Object " width:150 height:25 align:#centre
	button do_shdwmatte " Create Ground Plane" width:150 height:25 align:#centre
	)



group "Camera Tools"
	(
	radiobuttons S_W_N_E labels:#("South-West","North-West","North-East","South-East") columns:2 align:#centre height:30
	button do_cam " Create Camera " width:150 height:25 align:#centre
	--slider camdist "Camera Distance" range:[0,329,0] ticks:2
	slider out_size "Output Size" range:[1,150,100] ticks:15
	label show_out_size "100% (544x308)" align:#left
	)
group "Light Tools"
	(
	button do_shadow_lite " Create shadow light " width:150 height:25 align:#centre
	button do_cam_lite " Create Fill lights " width:150 height:25 align:#centre

	)



--group "GMAX - Prepare Screencap"
--	(
--	checkbox backgr "Set background" checked:true
--	checkbox remgrid "Remove grid" checked:true
--	button do_prepare " Prepare " width:80 height:25 align:#centre
--	)
---------------------------------------------------------------------------
on do_shadow_lite pressed do
(
		litepos = case S_W_N_E.state of
			(
				1:[-502.045,205.06,721.69] ----[-100,-100,81.65] [-500,220,725] 
				2:[205.06,502.045,721.69]--[-100,100,81.65]
				3:[502.045,-205.06,721.69]---[100,100,81.65]
				4:[-205.06,-502.045,721.69]--[100,-100,81.65]
			)


targetSpot name:"ShadowCaster" raytracedShadows:true castShadows:on target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) pos:litepos rgb:(color 255 255 255) shadowColor:(color 0 0 0) multiplier:.8 contrast:50 softenDiffuseEdge:50 nearAttenStart:0 nearAttenEnd:40 farAttenStart:80 farAttenEnd:200 decayRadius:40 atmosOpacity:100 atmosColorAmt:100 shadowMultiplier:1 hotspot:20 falloff:30 aspect:1 --isSelected:on
)

on do_cam_lite pressed do
(
		litepos1 = case S_W_N_E.state of
			(
				1:[-250,-250,250]
				2:[-250,250,250]
				3:[250,250,250]
				4:[250,-250,250]
			)
		litepos2 = case S_W_N_E.state of
			(
				1:[-250,-250,50]
				2:[-250,250,50]
				3:[250,250,50]
				4:[250,-250,50]
			)
		litepos3 = case S_W_N_E.state of
			(
				1:[0,-350,100]
				2:[-350,0,100]
				3:[0,350,100]
				4:[350,0,100]
			)


targetSpot name:"Cameralight" castShadows:on target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) pos:litepos1 rgb:(color 255 255 255) shadowColor:(color 0 0 0) multiplier:.4 contrast:25 softenDiffuseEdge:50 nearAttenStart:0 nearAttenEnd:40 farAttenStart:80 farAttenEnd:200 decayRadius:40 atmosOpacity:100 atmosColorAmt:100 shadowMultiplier:.25 hotspot:20 falloff:30 aspect:1 excludeList:#($Shadowplane)--isSelected:on 
targetSpot name:"Filllight01" castShadows:on target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) pos:litepos2 rgb:(color 255 255 255) shadowColor:(color 0 0 0) multiplier:.4 contrast:25 softenDiffuseEdge:50 nearAttenStart:0 nearAttenEnd:40 farAttenStart:80 farAttenEnd:200 decayRadius:40 atmosOpacity:100 atmosColorAmt:100 shadowMultiplier:1 hotspot:20 falloff:30 aspect:1 excludeList:#($Shadowplane)--isSelected:on 
targetSpot name:"Filllight02" castShadows:on target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) pos:litepos3 rgb:(color 255 255 255) shadowColor:(color 0 0 0) multiplier:.5 contrast:25 softenDiffuseEdge:50 nearAttenStart:0 nearAttenEnd:40 farAttenStart:80 farAttenEnd:200 decayRadius:40 atmosOpacity:100 atmosColorAmt:100 shadowMultiplier:1 hotspot:40 falloff:50 aspect:1 excludeList:#($Shadowplane)--isSelected:on 

)


on do_reffnd pressed do
( 
local mp_r,mp_l,mp_h
local sr,sl,sh,sl2,sr2
try (delete $Ref_Foundation) catch()

mp_r=1
mp_l=1
mp_h=1


--print reffnd_R.state
mp_r = case reffnd_R.state of
			(
				1:(1)
				2:(2)
				3:(3)
				4:(4)
				5:(5)
				6:(6)
			)
mp_l = case reffnd_L.state of
			(
				1:(1)
				2:(2)
				3:(3)
				4:(4)
				5:(5)
				6:(6)
			)
--mp_h = case reffnd_H.state of
--			(
--				1:(1)
--				2:(2)
--				3:(3)
--				4:(4)
--				5:(5)
--				6:(6)
--			)
mp_h = 2
sr=16.575*mp_r
sl=16.575*mp_l
sh=16.575*mp_h
sl2=(sl/2)
sr2=(sr/2)

trn = case S_W_N_E.state of
			(
				1:[-sl2,-sr2,0]
				2:[-sl2,sr2,0]
				3:[sl2,sr2,0]
				4:[sl2,-sr2,0]
			)

-- dummy name:"Ref_Foundation"  boxsize:[sl,sr,sh] pos:[-sl/2,-sr/2,sh/2]  backFaceCull:false  --pivot:[19.5/2,19.5/2,19.5/2]
box name:"Ref_Foundation" height:sh length:sr width:sl pos:trn xray:true
--viewport.activeViewport = 4
--max wire smooth
)


on do_shdwmatte pressed do
(
try (delete $ShadowPlane) catch ()
plane length:500 width:500 name:"ShadowPlane" gbufferChannel:13
$ShadowPlane.material= matteShadow() 
$ShadowPlane.material.color = color  85 255 85
$ShadowPlane.material.receiveShadows = true


)

 on do_prepare pressed do
 	(
		print "preparing GMAX"
		--max background
		--setBackGround [0,0,255]
	)

 on do_cam pressed do
	(
		try
		(	
			delete $lights
			delete $camera01
		)
		catch()

		viewport.ResetAllViews ()
		camd= case S_W_N_E.state of
			(
				1:[-100,-100,81.65]
				2:[-100,100,81.65]
				3:[100,100,81.65]
				4:[100,-100,81.65]
			)

		cam=Targetcamera  pos:camd isSelected:on target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]))
		cam.fov = 65.47
		cam.orthoProjection=true
		viewport.activeViewport = 4
		viewport.setCamera cam
		out_size.value=100
		animX=544
		animY=308
		show_out_size.text="100% (544x308)"
	)

on out_size changed val do
	(
		try
		(
			camd= case S_W_N_E.state of
			(
				1:[-100,-100,81.65]
		        2:[-100,100,81.65]
				3:[100,100,81.65]
				4:[100,-100,81.65]
			)
			$Camera01.pos = camd
			x=$Camera01.pos.x*(out_size.value/100)
			y=$Camera01.pos.y*(out_size.value/100)
			z=$Camera01.pos.z*(out_size.value/100)
			$Camera01.pos=[x,y,z]
			
			--$Camera01.pos=[$Camera01.pos[1]*(out_size.value/100),$Camera01.pos[2]*(out_size.value/100),$Camera01.pos[3]*(out_size.value/100)]			--$Camera01.pos = camd
			animX=544*(out_size.value/100)
			animY=308*(out_size.value/100)
			
			s=(out_size.value as string)+"% ("+(animX as string)+"x"+(animY as string)+")"
			show_out_size.text=s

			--animsize = [544*(out_size.value/100),308*(out_size.value/100)]
		)
		catch (messageBox "Life would be much better if you first make a CAMERA, don't you agree ...?")
	)

 on camdist changed val do
	(
		try
		(
			camd= case S_W_N_E.state of
			(
				1:[-100-camdist.value,-100-camdist.value,tan(30)*sqrt(2*(camdist.value*camdist.value))+81.65]
				2:[-100-camdist.value,100+camdist.value,tan(30)*sqrt(2*(camdist.value*camdist.value))+81.65]
				3:[100+camdist.value,100+camdist.value,tan(30)*sqrt(2*(camdist.value*camdist.value))+81.65]
				4:[100+camdist.value,-100-camdist.value,tan(30)*sqrt(2*(camdist.value*camdist.value))+81.65]
			)
			$Camera01.pos = camd
		)
		catch (messageBox "Life would be much better if you first make a CAMERA, don't you agree ...?")
	)
)--close rollout


rollout GMAXSHPTOOLS "GMAX   SHP TOOLS" 
(
)




rollout MAXSHPTOOLS "RA2   RENDER TOOLS" 
(
group "3DSMAX Setup" 
	(
		button do_renderfx " Add Contrast FX" width:150 height:25 align:#centre
		--button importlegalcolors " Import RA2 palette " width:150 height:25 enabled:false
		--progressbar import_progress color:red width:200 height:10 enabled:false
	)

group "3DSMAX Render" 
	(
	    radiobuttons render_mode labels:#("Render single frame","Render multiple frames") columns:1 align:#left height:30
		spinner inputfrme "Frame #                 " range:[0,100,0] fieldwidth:30 align:#left type:#integer
		spinner inputendfrme "to #                        " range:[0,100,0] fieldwidth:30 visible:false align:#left type:#integer

	    checkbox do_output "Output" width:210 align:#left checked:false
		checkbox zero_based "Zero-based filenames" width:210 align:#left checked:true enabled:false
		edittext output_file "Output filenames:" width:210 align:#centre text:"C:\frame" enabled:false
		label labtxt381 "+ [frame number] + '.bmp'" enabled:false align:#right
		label lab83295 " "
		
		button do_render " RENDER  " width:150 height:40 align:#centre
		label labtxt05 "Shadow Extraction Progress" align:#left --enabled:false
		progressbar shadow_progress color:red width:200 height:10 --enabled:false

	)
----------------------------------------------
on render_mode changed val do
    (
	    inputfrme.text=case render_mode.state of
		(
		    1:"Frame #"
			2:"From #"
		)
		if render_mode.state==2 then 
		(
		    inputendfrme.visible=true
		    if do_output.checked==true then (zero_based.enabled=true)
		)
		else
		(
		    inputendfrme.visible=false
			zero_based.enabled=false
		)
	)
	
on do_output changed val do
    (
	    output_file.enabled=val
		if render_mode.state==2 then (zero_based.enabled=val)
		labtxt381.enabled=val
	)

----------------------------------------------


on do_renderfx pressed do
	(
	global efx01
	efx01 = brightness_and_contrast Brightness:.35 Contrast:.70 ignore_background:true --ingnoreBack:true
	efx01.name= "RA2 WestWood Look"
	addEffect efx01
	)
------------------------------------------------

 on do_render pressed do
 	(
	global mymap
	global nomymap
	global efx01
	backgroundColor = color 0 0 255

	nomymap = bitmap animX animY
	mymap = bitmap animX animY
	
	start = inputfrme.value
	fin = inputendfrme.value
	out_f=0
	print fin
	
	if render_mode.state==1 do
	(
	    fin=start
		out_f=start
	)

for frme = start to fin do
	(
	$Shadowplane.ishidden=false
	render camera:$Camera01 outputsize:[animX,animY] to:mymap vfb:on frame:frme antiAliasing:false --shadows:false --antiAliasFilter:R_filter--fromframe:0 toframe:38
	--$Shadowplane.ishidden=false
	setActive efx01 false
	render camera:$Camera01 outputsize:[animX,animY] to:nomymap vfb:on frame:frme antiAliasing:false channels:#(#objectID) --antiAliasFilter:R_filter fromframe:0 toframe:38
	
	shadow_progress.value=0
	for r=0 to animY-1 do
		(
			
			shadow_pixels=getpixels nomymap [0,r] animX
			for c=1 to animX do 					
					(
						shadow_bmp=shadow_pixels[c]
						if shadow_bmp == (color 85 255 85)
						then
						(
						setpixels nomymap [c-1,r] #(color 0 0 198)
						setpixels mymap [c-1,r] #(color 0 0 255)
						)
						else
						(
						setpixels nomymap [c-1,r] #(color 0 0 255)
						)
					)
			shadow_progress.value = 100.*(r)/(animY-1)
		)
	shadow_progress.value=0
	
	display mymap
	display nomymap
		
	if do_output.checked==true do
	(
	
	    if render_mode.state==2 and zero_based.checked==false do (out_f=frme)
	
		frmnum="0"+(out_f as string)
		if out_f<100 do
		(
		  frmnum="0"+frmnum
		)
		if out_f<10 do
		(
		  frmnum="0"+frmnum
		)
		filename=output_file.text+" "+frmnum
		mymap.fileName=filename+".bmp"
		nomymap.fileName=filename+"_shadow.bmp"
		save mymap
		
		if render_mode.state==2 and zero_based.checked==true do
		(
		    fsum=out_f+(fin-start)+1
		    frmnum="0"+((fsum) as string)
			if fsum<100 do
			(
			    frmnum="0"+frmnum
			)
			if fsum<10 do
			(
			    frmnum="0"+frmnum
			)
			filename=output_file.text+" "+frmnum
			nomymap.fileName=filename+".bmp"
		)
		
		save nomymap
	)
	
	out_f=out_f+1
		
		setActive efx01 false

print "preparing MAX"
	)
)

)--end rneder rollout

rollout WHO_ "About" 
(
	label l1 "RA2 SHP TOOLS"
	label l2 "Version 1.2"
	label l3 "core by Flyby"
	label lb_en37d "ehanced by pd"
	
	label lb_439w3 "================================================"
	label lb_an2s8 "Enhancements by pd"
	label lb_3nsh3 "- No more anti-aliasing" align:#left
	label lb_je28s "- Render output" align:#left
	label lb_an27s "- Working output size option" align:#left
	label lb_an2ds "- Option to render specified frames" align:#left
	label lb_naw28 "- Fixed shadow position" align:#left
	label lb_wefw3 "================================================"
)

-- create the rollout window and add the  rollout
if FloaterExampleFloater != undefined do
				(
				closerolloutfloater FloaterExampleFloater
				)		
FloaterExampleFloater = newRolloutFloater "RED ALERT2 TOOLSET" 250 850 
addRollout SETUPTOOLS FloaterExampleFloater
addRollout MAXSHPTOOLS FloaterExampleFloater --rolledUp:true
--addRollout INFTOOLS FloaterExampleFloater rolledUp:true
addRollout WHO_ FloaterExampleFloater rolledUp:true


